const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Feature_flagsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const feature_flags = await db.feature_flags.create(
      {
        id: data.id || undefined,

        key: data.key || null,
        value: data.value || false,

        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await feature_flags.setOrganizations(data.organizations || null, {
      transaction,
    });

    return feature_flags;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const feature_flagsData = data.map((item, index) => ({
      id: item.id || undefined,

      key: item.key || null,
      value: item.value || false,

      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const feature_flags = await db.feature_flags.bulkCreate(feature_flagsData, {
      transaction,
    });

    // For each item created, replace relation files

    return feature_flags;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const feature_flags = await db.feature_flags.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.key !== undefined) updatePayload.key = data.key;

    if (data.value !== undefined) updatePayload.value = data.value;

    updatePayload.updatedById = currentUser.id;

    await feature_flags.update(updatePayload, { transaction });

    if (data.organizations !== undefined) {
      await feature_flags.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return feature_flags;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const feature_flags = await db.feature_flags.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of feature_flags) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of feature_flags) {
        await record.destroy({ transaction });
      }
    });

    return feature_flags;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const feature_flags = await db.feature_flags.findByPk(id, options);

    await feature_flags.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await feature_flags.destroy({
      transaction,
    });

    return feature_flags;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const feature_flags = await db.feature_flags.findOne(
      { where },
      { transaction },
    );

    if (!feature_flags) {
      return feature_flags;
    }

    const output = feature_flags.get({ plain: true });

    output.organizations = await feature_flags.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.key) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('feature_flags', 'key', filter.key),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.value) {
        where = {
          ...where,
          value: filter.value,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.feature_flags.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('feature_flags', 'key', query),
        ],
      };
    }

    const records = await db.feature_flags.findAll({
      attributes: ['id', 'key'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['key', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.key,
    }));
  }
};
